// Concentration 1.0
// by Jason Simpson (jason@xio.com)

int w,h,v[100],cw,ch,font;
initGrid() {
	int x,y,a,b;
	// I can't do error checking here,
	// I keep getting stack errors if
	// I put the gets() inside even a
	// simple while loop.
	w=h=gets("Enter grid size (must be even & <=10)");
	// How do you embed a line
	// break in a gets() prompt?

	// If I can't check for invalid
	// input, I can at least force it.
	w=(w/2)*2; h=(h/2)*2;
	if (w<2) {w=2; h=2;}
	if (w>10) {w=10; h=10;}
	cw=(160-1)/w;
	ch=(160-15)/h;
	font=6;
	if (w>6) font=2;
	if (w>8) font=0;
	for (y=0;y<h;y++) {
		b=15+y*ch;
		line(1,0,b,0,b+(ch-1));
		for (x=0;x<w;x++) {
		a=1+x*cw;
	v[y*w+x]=(y*w+x+2)/2;
		line(1,a+(cw-1),b,
			a+(cw-1),b+(ch-1));
		line(1,a,b+(ch-1),
			a+(cw-1),b+(ch-1));
		}
	}
}
shuffle() {
	int s,t,i;
	for (i=0;i<(w*h);i++) {
		s=random(w*h);
		t=v[s];
		v[s]=v[i];
		v[i]=t;
	}
}
showSq(int x, int y) {
	int a,b,s;
	a=(x-1)/cw;
	b=(y-15)/ch;
	if (a<0 || a>=w || b<0 || b>=h)
		return -1;
	s=b*w+a;
	if (v[s]<0) return -1;
	textattr(font,1,0);
	text(3+a*cw,17+b*ch,v[s]);
	return s;
}
hideSq(int s, int c) {
	int a,b;
	if (s<0 || v[s]<0) return;
	a=1+(s%w)*cw;
	b=15+(s/w)*ch;
rect(c,a,b,a+(cw-1),b+(ch-1),0);
	if (c) v[s]=-1;
}
main() {
	int s1,s2,os1,os2,c,miss;
	int pct;
	while (1) {
	graph_on();
	title("Concentration");
	initGrid();
	shuffle();
	miss=0;
	c=w*h;
	os1=os2=0;
while (c>0) {
	s1=s2=-1;
	while (s1<0) {
	waitp();
	if (os1>=0) hideSq(os1,0);
	if (os2>=0) hideSq(os2,0);
	s1=showSq(penx(),peny());
	}

	while (s2<0 || s2==s1) {
	waitp();
	s2=showSq(penx(),peny());
	}

	if (v[s1]==v[s2]) {
	hideSq(s1,1); c--;
	hideSq(s2,1); c--;
	} else {
	miss++;
	textattr(0,1,0);
	text(82,2,"Misses: " + miss);
	}

	os1=s1;
	os2=s2;
} // while c>0
pct=(miss*100)/(w*h);
graph_off();
clear();
puts("You cleared the field with ");
puts(miss + " misses. That's ");
puts(pct + "%. ");
puts("(Lower is better.)\n\n");
puts("Tap to play again.");
wait();
} // while 1
} // main()